/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package vostokjsonlibsample.bean;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.vostok.json.ObjectConverterInterface;
import org.vostok.json.ParserException;

/**
 *
 * @author levreau.jerome@vostoksystem.eu
 */
public class LatLngConverter implements ObjectConverterInterface {

	static Pattern p = Pattern.compile("\\s*\\[\\s*([\\d\\.]+)\\s*,\\s*([\\d\\.]+)\\s*\\]\\s*");

	@Override
	public String getString(Object obj) throws ParserException {

		if (obj instanceof LatLng == false) {

			throw new ParserException("Not a LatLng obj");
		}

		LatLng ll = (LatLng) obj;

		StringBuilder str = new StringBuilder("[").append(ll.getLat()).append(',').append(ll.getLng()).append(']');

		return str.toString();
	}

	@Override
	public Object getObject(String data) throws ParserException {

		try {
			Matcher m = p.matcher(data);
			if (m.matches()) {
				LatLng o = new LatLng();
				o.setLat(Double.valueOf(m.group(1)));
				o.setLng(Double.valueOf(m.group(2)));

				return o;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		throw new ParserException("can't parse data into a LatLng object");
	}
}
